"use strict";
/*!
 * Copyright (c) 2021-present, Okta, Inc. and/or its affiliates. All rights reserved.
 * The Okta software accompanied by this notice is provided pursuant to the Apache License, Version 2.0 (the "License.")
 *
 * You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0.
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *
 * See the License for the specific language governing permissions and limitations under the License.
 */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.tokenObjectExpression = exports.identityObjectProxyVariableDeclaration = exports.identityObjectProxy = exports.variableDeclaration = void 0;
const t = __importStar(require("@babel/types"));
const template_1 = __importDefault(require("@babel/template"));
function variableDeclaration({ name, tokens, styles, digest, }) {
    return t.variableDeclaration("const", [
        t.variableDeclarator(t.identifier(name), tokenObjectExpression({ tokens, styles, digest })),
    ]);
}
exports.variableDeclaration = variableDeclaration;
function identityObjectProxy() {
    return t.newExpression(t.identifier("Proxy"), [
        t.objectExpression([]),
        t.objectExpression([
            t.objectProperty(t.identifier("get"), t.functionExpression(null, [t.identifier("target"), t.identifier("key")], t.blockStatement([
                t.ifStatement(t.binaryExpression("===", t.identifier("key"), t.stringLiteral("__esModule")), t.blockStatement([t.returnStatement(t.booleanLiteral(false))])),
                t.returnStatement(t.identifier("key")),
            ]))),
        ]),
    ]);
}
exports.identityObjectProxy = identityObjectProxy;
function identityObjectProxyVariableDeclaration({ name, }) {
    return t.variableDeclaration("const", [
        t.variableDeclarator(t.identifier(name), identityObjectProxy()),
    ]);
}
exports.identityObjectProxyVariableDeclaration = identityObjectProxyVariableDeclaration;
function tokenObjectExpression({ tokens, styles, digest, }) {
    const body = template_1.default.ast(`return \`${styles}\``);
    return t.objectExpression([
        t.objectProperty(t.identifier("__digest"), t.stringLiteral(digest)),
        t.objectProperty(t.identifier("__template"), t.functionExpression(null, [t.identifier("theme")], t.blockStatement([body]))),
        ...tokenObjectProperties(tokens),
    ]);
}
exports.tokenObjectExpression = tokenObjectExpression;
function tokenObjectProperties(tokens) {
    return Object.entries(tokens).map(([key, value]) => t.objectProperty(t.stringLiteral(key), t.stringLiteral(value)));
}
